/*
 * Created on Jun 1, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package cpr;

import org.boxed_economy.besp.model.fmfw.behavior.AbstractBehavior;

import org.boxed_economy.besp.model.fmfw.ChannelEvent;
import org.boxed_economy.besp.model.fmfw.behavior.Action;
import org.boxed_economy.besp.model.fmfw.behavior.CompositeState;
import org.boxed_economy.besp.model.fmfw.behavior.State;
import org.boxed_economy.besp.model.fmfw.behavior.StateMachineFactory;
import org.boxed_economy.besp.model.fmfw.behavior.Transition;

import org.boxed_economy.besp.model.fmfw.behavior.Event;
import org.boxed_economy.besp.model.fmfw.behavior.GuardCondition;

/**
* AbstractReactionBehavior
*/
public abstract class AbstractReactionBehavior extends AbstractBehavior {

	/**
	* This method automatically generated from Boxed Economy Behavior Editor.
	* Don't modify this method.
	*/
	protected void initializeStateMachine() {
		//factory
		StateMachineFactory factory = this.getStateMachine();

		//states
		State initialState = factory.createInitialState();
		CompositeState silent = factory.createCompositeState("Silent");
		CompositeState unconscious =
			factory.createCompositeState("Unconscious");
		CompositeState cPRed = factory.createCompositeState("CPRed");
		CompositeState conscious = factory.createCompositeState("Conscious");
		CompositeState thank_you_ = factory.createCompositeState("Thank you!");

		//actions
		Action cpredAction = new Action() {
			public void doAction() {
				cpredAction();
			}
			public String toString() {
				return "cpredAction";
			}
		};
		Action consciousAction = new Action() {
			public void doAction() {
				consciousAction();
			}
			public String toString() {
				return "consciousAction";
			}
		};
		Action criedAction = new Action() {
			public void doAction() {
				criedAction();
			}
			public String toString() {
				return "criedAction";
			}
		};
		Action silentAction = new Action() {
			public void doAction() {
				silentAction();
			}
			public String toString() {
				return "silentAction";
			}
		};
		Action sayingthankyouAction = new Action() {
			public void doAction() {
				sayingthankyouAction();
			}
			public String toString() {
				return "sayingthankyouAction";
			}
		};

		//guard-conditions
		GuardCondition isConsciousInformation = new GuardCondition() {
			public boolean isMatched(Event e) {
				return isConsciousInformation(e);
			}
		};
		GuardCondition isCPRGoods = new GuardCondition() {
			public boolean isMatched(Event e) {
				return isCPRGoods(e);
			}
		};

		//transitions
		Transition transitionUnconsciousToCPRed = factory.createTransition();
		Transition transitionSilentToUnconscious = factory.createTransition();
		Transition transitionCPRedToCPRed = factory.createTransition();
		Transition transitionSilentToSilent = factory.createTransition();
		Transition transitionInitialStateToSilent = factory.createTransition();
		Transition transitionCPRedToConscious = factory.createTransition();
		Transition transitionConsciousToThank_you_ = factory.createTransition();

		//states setting

		//structure of states
		this.setInitialState(initialState);
		this.addState(silent);
		this.addState(unconscious);
		this.addState(cPRed);
		this.addState(conscious);
		this.addState(thank_you_);

		//transitions setting
		transitionUnconsciousToCPRed.setEvent(ChannelEvent.class);
		transitionUnconsciousToCPRed.addAction(silentAction);
		transitionSilentToUnconscious.setEvent(ChannelEvent.class);
		transitionSilentToUnconscious.setGuardCondition(isConsciousInformation);
		transitionSilentToUnconscious.addAction(criedAction);
		transitionSilentToUnconscious.addAction(silentAction);
		transitionCPRedToCPRed.setEvent(ChannelEvent.class);
		transitionCPRedToCPRed.addAction(silentAction);
		transitionSilentToSilent.setEvent(ChannelEvent.class);
		transitionSilentToSilent.addAction(silentAction);
		transitionCPRedToConscious.setGuardCondition(isCPRGoods);
		transitionCPRedToConscious.addAction(cpredAction);
		transitionCPRedToConscious.addAction(consciousAction);
		transitionConsciousToThank_you_.setEvent(ChannelEvent.class);
		transitionConsciousToThank_you_.addAction(sayingthankyouAction);

		//connection of transitions
		transitionUnconsciousToCPRed.setSourceState(unconscious);
		transitionUnconsciousToCPRed.setTargetState(cPRed);
		transitionSilentToUnconscious.setSourceState(silent);
		transitionSilentToUnconscious.setTargetState(unconscious);
		transitionCPRedToCPRed.setSourceState(cPRed);
		transitionCPRedToCPRed.setTargetState(cPRed);
		transitionSilentToSilent.setSourceState(silent);
		transitionSilentToSilent.setTargetState(silent);
		transitionInitialStateToSilent.setSourceState(initialState);
		transitionInitialStateToSilent.setTargetState(silent);
		transitionCPRedToConscious.setSourceState(cPRed);
		transitionCPRedToConscious.setTargetState(conscious);
		transitionConsciousToThank_you_.setSourceState(conscious);
		transitionConsciousToThank_you_.setTargetState(thank_you_);

	}

	/**
	*cpredAction
	*/
	protected abstract void cpredAction();
	/**
	*consciousAction
	*/
	protected abstract void consciousAction();
	/**
	*criedAction
	*/
	protected abstract void criedAction();
	/**
	*silentAction
	*/
	protected abstract void silentAction();
	/**
	*sayingthankyouAction
	*/
	protected abstract void sayingthankyouAction();
	/**
	*isConsciousInformation
	*/
	protected abstract boolean isConsciousInformation(Event e);
	/**
	*isCPRGoods
	*/
	protected abstract boolean isCPRGoods(Event e);
}
