 /*
 * HolykoshiYasnoriModel.java
 */
package cpr;

import org.boxed_economy.besp.container.BESPContainer;
import org.boxed_economy.besp.container.BESPPlugin;
import org.boxed_economy.besp.model.ModelContainer;
import org.boxed_economy.besp.model.fmfw.AgentType;
import org.boxed_economy.besp.model.fmfw.GoodsType;
import org.boxed_economy.besp.model.fmfw.BehaviorType;
import org.boxed_economy.besp.model.fmfw.InformationType;
import org.boxed_economy.besp.model.fmfw.RelationType; 

/**
 * Model for Boxed Economy Foundation Model Framework
 *
 * @generated modifiable
 * @version $$Id$$
 */
public class HolykoshiYasnoriModel implements BESPPlugin {
	
	public static AgentType AGENTTYPE_GentleReaderAgent;
	public static AgentType AGENTTYPE_UnconsciousPersonAgent;
	
	public static AgentType AGENTTYPE_PasserbyAgent;
	public static BehaviorType BEHAVIORTYPE_CPRBehavior;
	
	public static BehaviorType BEHAVIORTYPE_ReactionBehavior;
	
	public static BehaviorType BEHAVIORTYPE_Call119Behavior;
	public static RelationType RELATIONTYPE_CPRRelation;
	
	public static RelationType RELATIONTYPE_Call119Relation;
	
	public static InformationType INFORMATIONTYPE_ConsciousInformation;
	
	public static InformationType INFORMATIONTYPE_CPRInformation;
	public static GoodsType GOODSTYPE_RescueBreathingGoods;
	public static GoodsType GOODSTYPE_CardiacMassageGoods;
	
	/** 
	* This method will be modified automatically by Model Editor 
	*
	* @generated
	*/
	public static void initializePlugin(BESPContainer container) {
		installTypes(container);
		buildStructure(container);
		setPriority(container);
	}

	/** 
	* This method will be modified automatically by Model Editor
	*
	* @generated
	*/
	private static void installTypes(BESPContainer container) {
		//Get the model container  
		ModelContainer modelContainer = container.getModelContainer();
		
		AGENTTYPE_UnconsciousPersonAgent=modelContainer.installAgentType("cpr.UnconsciousPersonAgent");
		AGENTTYPE_PasserbyAgent=modelContainer.installAgentType("cpr.PasserbyAgent");
		AGENTTYPE_GentleReaderAgent=modelContainer.installAgentType("cpr.GentleReaderAgent");
		BEHAVIORTYPE_CPRBehavior=modelContainer.installBehaviorType("cpr.CPRBehavior");
		BEHAVIORTYPE_ReactionBehavior=modelContainer.installBehaviorType("cpr.ReactionBehavior");
		BEHAVIORTYPE_Call119Behavior=modelContainer.installBehaviorType("cpr.Call119Behavior");
		RELATIONTYPE_CPRRelation=modelContainer.installRelationType("cpr.CPRRelation");
		RELATIONTYPE_Call119Relation=modelContainer.installRelationType("cpr.Call119Relation");
		INFORMATIONTYPE_ConsciousInformation=modelContainer.installInformationType("cpr.ConsciousInformation");
		INFORMATIONTYPE_CPRInformation=modelContainer.installInformationType("cpr.CPRInformation");
		GOODSTYPE_RescueBreathingGoods=modelContainer.installGoodsType("cpr.RescueBreathingGoods");
		GOODSTYPE_CardiacMassageGoods=modelContainer.installGoodsType("cpr.CardiacMassageGoods");
	}

	/** 
	* This method will be modified automatically by Model Editor 
	*
	* @generated
	*/
	private static void buildStructure(BESPContainer container) {
		ModelContainer modelContainer = container.getModelContainer();
		
	}

	/** 
	* Set priority 
	*
	* @generated modifiable
	*/	
	private static void setPriority(BESPContainer container) {
		ModelContainer modelContainer = container.getModelContainer();
		
		//:TODO set priority
	}
}